﻿using System.Collections.Generic;
using System.Windows;
using Stimulsoft.Report;

namespace StimulsoftTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void DesignButtonClick(object sender, RoutedEventArgs e)
        {
            StiReport report = new StiReport();
            report.RegData("PersonList", new List<Person>()); //Empty list to create a data source in the report
            report.RegData("MetaData", new MetaData());
            report.Load(@"Report.mrt");  
            report.DesignWithWpf();

            LoadReportIntoViewer();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            LoadReportIntoViewer();
        }

        private void LoadReportIntoViewer()
        {
            var report = new StiReport();
            report.RegData("PersonList", new List<Person>());
            report.RegData("MetaData", new MetaData());
            report.Load(@"Report.mrt");            
            stiViewer.Report = report;
            report.Render(true);
        }
    }

    public class MetaData
    {
        public IReportService ReportService { get; protected set; }

        public MetaData()
        {
            ReportService = new ReportService();
        }
    }

    public class ReportService: IReportService
    {
        public IList<Person> FindPersons(string name)
        {
            return new List<Person>
                       {
                           new Person("Fred Flintstone", "fred@flintstone.com", "12345678"),
                           new Person("Wilma Flintstone", "wilma@flintstone.com", "12345678")
                       };
        }
    }

    public interface IReportService
    {
        IList<Person> FindPersons(string name);
    }


    public class Person
    {
        public Person(string name, string email, string phone)
        {
            Name = name;
            Email = email;
            Phone = phone;
        }

        public string Name { get; set; }
        public string Email { get; set; }
        public string Phone { get; set; }
    }

}
